' touch.VBS V1.01 (C) yoshioka.teruo@nifty.com 2004-08-31
' Usage: touch [-0|-N|-o|-n|-t "yyyy/mm/dd hh:mm:ss"] files...

Option Explicit

Dim arg
Dim argc
Dim argv()
Dim fso
Set fso=CreateObject("Scripting.FileSystemObject")

For Each arg In Wscript.Arguments
  If InStr(arg,"*") Then
    call glob(arg)
  ElseIf InStr(arg,"?") Then
    call glob(arg)
  Else
    argc=argc+1
    ReDim Preserve argv(argc-1)
    argv(argc-1)=arg
  End If
Next

Function Glob(arg)
Dim Folder
Dim pre
Dim bre
Dim xre
Dim file
Dim dir
Dim found

dir=fso.GetParentFolderName(fso.GetAbsolutePathName(arg))
Set Folder=fso.GetFolder(dir)
Set pre=New RegExp
Set bre=New RegExp
Set xre=New RegExp
pre.Global=True
bre.IgnoreCase=True
xre.IgnoreCase=True
pre.Pattern="([\]\^\[\\\$\+\.\(\)\|\{\}])"
bre.Pattern="^" & pre.Replace(fso.GetBaseName(arg),"\$1") & "$"
bre.Pattern=Replace(bre.Pattern,"?",".")
bre.Pattern=Replace(bre.Pattern,"*",".*")
xre.Pattern="^" & pre.Replace(fso.GetExtensionName(arg),"\$1") & "$"
xre.Pattern=Replace(xre.Pattern,"?",".")
xre.Pattern=Replace(xre.Pattern,"*",".*")

For Each file In Folder.Files
  If bre.Test(fso.GetBaseName(file.Name)) And xre.Test(fso.GetExtensionName(file.Name)) Then
    argc=argc+1
    ReDim Preserve argv(argc-1)
    argv(argc-1)=file.Path
    found=True
  End If
Next
If Not found Then
  argc=argc+1
  ReDim Preserve argv(argc-1)
  argv(argc-1)=arg
End If
End Function

Dim folders()
Dim Shell
Dim Folder
Dim FolderItem
Dim n,k
Dim files()
Dim times()
Dim file
Dim prompt
Dim ans
Dim otime
Dim ntime

Set fso=CreateObject("Scripting.FileSystemObject")

n=argc
ReDim folders(n)
ReDim files(n)
ReDim times(n)
ntime=0
otime=Now

n=0
times(n)=Now
prompt=n & Space(1) & times(n) & Space(1) & "[Now]" & vbCRLF
For k=1 To argc
  arg=argv(k-1)
  If Left(arg,1)="-" Then
    If Not IsEmpty(ans) Then
      WScript.Echo "Invalid Option :",arg
      WScript.Quit
    End If
    If LCase(arg)="-t" Then
      ans=WScript.Arguments(k)
      k=k+1
      If InStr(ans," ")=0 And IsDate(WScript.Arguments(k)) Then
        ans=ans & " " & WScript.Arguments(k)
        k=k+1
      End If
    Else
      ans=Mid(arg,2)
    End If
  Else
    n=n+1
    Set file=fso.GetFile(arg)
    folders(n)=fso.GetParentFolderName(file.Path)
    files(n)=file.Name
    times(n)=file.DateLastModified
    prompt=prompt & n & Space(1) & times(n) & Space(1) & files(n) & vbCRLF
    If times(n)<otime Then otime=times(n)
    If times(n)>ntime Then ntime=times(n)
  End If
Next
If n=0 Then
  WScript.Echo "Usage: touch [-0|-N|-o|-n|-t ""yyyy/mm/dd hh:mm:ss""] files..."
  WScript.Quit
End If

If IsEmpty(ans) Then
  ans=InputBox(prompt,"Select or Enter Date & Time",times(0))
End If

If ans="" Then
  WScript.Quit
End If

If IsNumeric(ans) Then
  k=CLng(ans)
  If 0<=k And k<=n Then
    ans=times(k)
  Else
    WScript.Echo "Invalid Date & Time :",ans
    WScript.Quit
  End If
ElseIf LCase(ans)="o" Then
  ans=otime
ElseIf LCase(ans)="n" Then
  ans=ntime
ElseIf IsDate(ans) Then
  ans=CDate(ans)
Else
  WScript.Echo "Invalid Date & Time :",ans
  WScript.Quit
End If

Set Shell=CreateObject("Shell.Application")
For k=1 To n
  Set Folder=shell.NameSpace(folders(k))
  If Not (Folder Is Nothing) Then
    Set FolderItem=Folder.Items.Item(files(k))
    FolderItem.ModifyDate=ans
  End If
Next
